import React from 'react';
import ReactDOM from 'react-dom';
import './index.css';
import App from './App';
import registerServiceWorker from './registerServiceWorker';
import {Humidity, MesYeux, Temperature, TimeSeries} from "./model";

var list = []
//Pour l'affichage sur la page web
var listsensor=[]



var mqtt = require('mqtt')
//oon crée un client qui conecte le client à mqtt brocker
var client = mqtt.connect('mqtt://localhost:8080')

//une liste ou on stocke les sensor pour vérifier la répititivité

//cette fonction permet au client de s'abonner au Broker mqtt pour récupérer tous ce que les capteurs difusent
client.on('connect', function () {
    client.subscribe('#')


})







client.on('message', function (topic, message) {


    createObject(message, topic);



})




/**
 * cette fonction verfier l'existance d'un sensor dans une liste de sensor déja existant
 * dans cette liste
 * @param {*} list list des sensor
 * @param {*} idSensor identifiant du Sensor en cours
 */
function sensorExite(list, idSensor) {
    var obj = []
    var bool = false
    var ind = 0


    for (var i = 0; i < list.length; i++) {

        if (list[i].id === idSensor) {
            bool = true
            ind = i

        }




    }

    obj.push(bool)
    obj.push(ind)

    return obj;

}


/** cette fonction permet de creer ou mettre ajour un
 * instance d'un capteure selon son identifiant
 * on les arrange dans un liste à chaque fois on
 * verifie la redendance un capteurs s'il existe déja
 * on mis ajour sa valeur en la stoquant à l'aide de lobjet Timeseries
 * et on calcul à chaque fois la moyenne des valeur
 * et on affiche tous sur un page web
 *
 */

function createObject(message, topic) {
    var temperature

    var objet = JSON.parse(message.toString())
    var idSensor = topic.substring(6)
    var type = objet.type
    var existSensor = []

    existSensor = sensorExite(list, idSensor)

    switch (idSensor) {

        case 'temperatureChambre':

            //s'il cette objet n'exite pas dans la liste
            if (!existSensor[0]) {


                // objet de type Temperateur
                temperature = new Temperature();
                var   timeSerise = new TimeSeries()
                temperature.id = topic.substring(6);
                temperature.valTemperature = objet.value;
                temperature.timeSeries=timeSerise
                temperature.timeSeries.remplirListValues(objet.value)
                temperature.date = Date.now().toLocaleString();
                list.push(temperature)
                listsensor[idSensor]=temperature

            } else {

                list[existSensor[1]].valTemperature=objet.value
                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                listsensor[idSensor]=list[existSensor[1]]


            }
            if(listsensor[idSensor]!=="undefined"){
            ReactDOM.render(<App  listsensors={listsensor[idSensor]}/>, document.getElementById('root'));}


            break
        case 'temperatureSalleA111':


            if (!existSensor[0]) {

                // objet de type Temperateur
                temperature = new Temperature();
                var   timeSerise = new TimeSeries()

                temperature.id = topic.substring(6);
                temperature.valTemperature = objet.value;
                temperature.timeSeries=timeSerise
                temperature.timeSeries.remplirListValues(objet.value)
                temperature.date = Date.now().toLocaleString();
                list.push(temperature)
                listsensor[idSensor]=temperature

            } else {
                list[existSensor[1]].valTemperature=objet.value
                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                listsensor[idSensor]=list[existSensor[1]]
            }

            if(listsensor[idSensor]!=="undefined"){
                ReactDOM.render(<App  listsensors={listsensor[idSensor]}/>, document.getElementById('root'));}




            break

        case 'MonAttention':

            if (!existSensor[0]) {
                var timeSerise = new TimeSeries()

                var humidity = new Humidity();
                humidity.id = topic.substring(6);
                humidity.valHumidity = objet.value;
                humidity.timeSeries = timeSerise;
                humidity.timeSeries.remplirListValues(humidity.valHumidity);


                humidity.date = Date.now();

                list.push(humidity)



                listsensor[idSensor]=humidity


            } else {

                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                list[existSensor[1]].valHumidity=objet.value
                list[existSensor[1]].date = new Date().toLocaleString();

                listsensor[idSensor]=list[existSensor[1]]
            }
            if(listsensor[idSensor]!=="undefined"){
                ReactDOM.render(<App  listsensors={listsensor[idSensor]}/>, document.getElementById('root'));}
            break

        case 'MesYeux':
            if (!existSensor[0]) {

                var mesYeux = new MesYeux();

                var timeSerise = new TimeSeries()
                mesYeux.id = topic.substring(6);
                mesYeux.etat = objet.value;
                mesYeux.timeSeries=timeSerise
                mesYeux.timeSeries.remplirListValues(objet.value)
                mesYeux.date = Date.now().toLocaleString();
                list.push(mesYeux)
                listsensor[idSensor]=mesYeux



            } else {
                list[existSensor[1]].etat = objet.value;
                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                list[existSensor[1]].date = new Date().toLocaleString();
                listsensor[idSensor]=list[existSensor[1]]


            }
            if(listsensor[idSensor]!=="undefined"){
                ReactDOM.render(<App  listsensors={listsensor[idSensor]}/>, document.getElementById('root'));}
            break;

        default:
            console.log("Désolé, nous n'avons plus de captuer  ");
    }

}

ReactDOM.render(<App />, document.getElementById('root'));
registerServiceWorker();


